(function ($) {	
    $.fn.hot_key = function(){
        kbd.bind(this, arguments);
        return this;
    }

    $.hot_key = function(){
        kbd.bind( $(document), arguments);
        return this;
    }

    var kbd = {
        conf:{},
		keyCodes : {
			// Alphabet
			a:65, b:66, c:67, d:68, e:69,
			f:70, g:71, h:72, i:73, j:74,
			k:75, l:76, m:77, n:78, o:79,
			p:80, q:81, r:82, s:83, t:84,
			u:85, v:86, w:87, x:88, y:89, z:90,
			// Numbers
			n0:48, n1:49, n2:50, n3:51, n4:52,
			n5:53, n6:54, n7:55, n8:56, n9:57,
			// Controls
			tab:  9, enter:13, shift:16, backspace:8,
			ctrl:17, alt  :18, esc  :27, space    :32,
			menu:93, pause:19, cmd  :91,
			insert  :45, home:36, pageup  :33,
			'delete':46, end :35, pagedown:34,
			// F*
			f1:112, f2:113, f3:114, f4 :115, f5 :116, f6 :117,
			f7:118, f8:119, f9:120, f10:121, f11:122, f12:123,
			// numpad
			np0: 96, np1: 97, np2: 98, np3: 99, np4:100,
			np5:101, np6:102, np7:103, np8:104, np9:105,
			npslash:11,npstar:106,nphyphen:109,npplus:107,npdot:110,
			// Lock
			capslock:20, numlock:144, scrolllock:145,
			
			// Symbols
			equals: 61, hyphen   :109, coma  :188, dot:190,
			gravis:192, backslash:220, sbopen:219, sbclose:221,
			slash :191, semicolon: 59, apostrophe : 222,
			// Arrows
			aleft:37, aup:  38, aright:39, adown:40
		},
        keys_stack:[],

        __key_up_handler: function(obj,e){
             var obj = $(obj);
             var conf = obj.data('conf');

             if( kbd.__check_rule(conf) ){
                 conf.callback();
             }

             kbd.keys_stack = [];
        },

        __key_down_handler: function(obj,e){
             if(! kbd.__in(e.keyCode, kbd.keys_stack)){
                kbd.keys_stack.push(e.keyCode);
             }
        },

        __parse_args: function(args){
             var conf = {};
             conf.keys_template = args[0];
             conf.codes_template = [];

             var tmp = args[0];
             tmp = tmp.split(' ');

             for(var cnt=0; cnt<tmp.length; cnt++){
                conf.codes_template.push( kbd.keyCodes[tmp[cnt]] );
             }

             if( typeof args[1] == 'function' ){
                 conf.callback = args[1];
             }else if( typeof args[1] == 'object' ){
                 conf.settings = args[1];
                 conf.callback = args[2];
             }
             return conf;
        },

        __check_rule: function(conf){
            if( conf == undefined ){ return false; }
            var result = true;

            for(var cnt=0;cnt<conf.codes_template.length; cnt++){
                result = result && kbd.__in(conf.codes_template[cnt],kbd.keys_stack);
                if(!result){ return false; }
            }
            return result;
        },
        __in: function(elem, arr){
            var result = false;
            for(cnt=0;cnt<arr.length;cnt++){
                result = result || (arr[cnt] == elem);
                if(result){ return true; }
            }
            return result;
        },
        bind: function(obj, args){
            obj.data('conf', kbd.__parse_args(args)); 
            obj.keydown( function(e){ 
                    kbd.__key_down_handler(obj,e);
                    } );
            obj.keyup( function(e){
                    kbd.__key_up_handler(obj,e);
                    } );
        }
    }
})(jQuery);
